import { TestPlan } from "@xstate/test/lib/types";
import * as d from "io-ts/lib/Decoder";
import { Deferred } from "./delay";
declare class _<T> {
    Action: d.Decoder<unknown, ["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: T) => unknown)>;
    Configuration: d.Decoder<unknown, {
        id: string;
        visit: {
            path: string;
        };
        initial: string;
        states: Record<string, Partial<{
            xstate: Partial<{
                always: string;
            }>;
            type: "final";
            tests: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext) => unknown))[];
            on: Record<string, Partial<{
                target: string;
                actions: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext) => unknown))[];
            }>>;
        }>>;
    } & Partial<{
        beforeVisit: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext) => unknown))[];
        apis: (Partial<{
            deferrals: string[];
            outcomes: Record<string, Partial<{
                status: number;
                body: any;
            }>>;
        }> & {
            path: string;
        })[];
        outcomes: string[];
        viewport: {
            width: number;
            height: number;
        };
    }>>;
}
export declare type Action<TTestContext> = d.TypeOf<_<TTestContext>["Action"]>;
export declare type Configuration<TTestContext> = d.TypeOf<_<TTestContext>["Configuration"]>;
declare const _default: <TTestContext>(json: any) => import("fp-ts/lib/Either").Either<import("io-ts/lib/FreeSemigroup").FreeSemigroup<import("io-ts/lib/DecodeError").DecodeError<string>>, {
    id: string;
    visit: {
        path: string;
    };
    initial: string;
    states: Record<string, Partial<{
        xstate: Partial<{
            always: string;
        }>;
        type: "final";
        tests: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext_1) => unknown))[];
        on: Record<string, Partial<{
            target: string;
            actions: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext_1) => unknown))[];
        }>>;
    }>>;
} & Partial<{
    beforeVisit: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext_1) => unknown))[];
    apis: (Partial<{
        deferrals: string[];
        outcomes: Record<string, Partial<{
            status: number;
            body: any;
        }>>;
    }> & {
        path: string;
    })[];
    outcomes: string[];
    viewport: {
        width: number;
        height: number;
    };
}>>;
export default _default;
declare const defaultSelectorWrapper: (selector: string) => string;
declare type Options = {
    selectorWrapper?: (selector: string) => string;
    server?: string;
    xstateInspect?: boolean;
    ports?: {
        ci?: number;
        prod?: number;
        dev?: number;
    };
};
export declare const make: <TTestContext>(actionsParser: (selectorWrapper: typeof defaultSelectorWrapper) => (buffer: Deferred[]) => (actions: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext) => unknown | Promise<unknown>))[]) => (testContext: TTestContext) => Promise<any>) => (withPlans: (setup: {
    buffer: Deferred<any>[];
    config: {
        id: string;
        visit: {
            path: string;
        };
        initial: string;
        states: Record<string, Partial<{
            xstate: Partial<{
                always: string;
            }>;
            type: "final";
            tests: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext_1) => unknown | Promise<unknown>))[];
            on: Record<string, Partial<{
                target: string;
                actions: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext_1) => unknown | Promise<unknown>))[];
            }>>;
        }>>;
    } & Partial<{
        beforeVisit: (["delay", number] | ["resolve" | "waitForFocus", string] | ["waitForSelector" | "$" | "click" | "defer", string | string[]] | ["type", string, string | number] | ["select", string, string] | ["expectProperty", string, string, string | number | boolean] | ((page: TTestContext_1) => unknown | Promise<unknown>))[];
        apis: (Partial<{
            deferrals: string[];
            outcomes: Record<string, Partial<{
                status: number;
                body: any;
            }>>;
        }> & {
            path: string;
        })[];
        outcomes: string[];
        viewport: {
            width: number;
            height: number;
        };
    }>;
    pattern: string[][][];
    plans: TestPlan<TTestContext, unknown>[];
    url: string;
    selectorWrapper: typeof defaultSelectorWrapper;
}) => void) => ({ selectorWrapper, ports: ports_, server, xstateInspect, }?: Options) => (json: any) => void;
