"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.make = void 0;
const test_1 = require("@xstate/test");
const d = __importStar(require("io-ts/lib/Decoder"));
const xstate_1 = require("xstate");
const pageFnDecoder = () => ({
    decode: (fn) => typeof fn === "function"
        ? d.success(fn)
        : d.failure(fn, "Function: (page: Page) => any"),
});
const actionDecoder = () => d.union(d.tuple(d.literal("delay"), d.number), pageFnDecoder(), d.tuple(d.union(d.literal("resolve"), d.literal("waitForFocus")), d.string), d.tuple(d.union(d.literal("waitForSelector"), d.literal("$"), d.literal("click"), d.literal("defer")), d.union(d.string, d.array(d.string))), d.tuple(d.literal("type"), d.string, d.union(d.number, d.string)), d.tuple(d.literal("select"), d.string, d.string), d.tuple(d.literal("expectProperty"), d.string, d.string, d.union(d.number, d.boolean, d.string)));
const valueDecoder = d.nullable(d.union(d.string, d.number, d.boolean));
const jsonDecoder = d.lazy("JSON", () => d.union(valueDecoder, d.array(jsonDecoder), d.record(jsonDecoder)));
const configDecoder = () => {
    const actionD = d.array(actionDecoder());
    return d.intersect(d.partial({
        beforeVisit: actionD,
        apis: d.array(d.intersect(d.type({ path: d.string }))(d.partial({
            deferrals: d.array(d.string),
            outcomes: d.record(d.partial({
                status: d.number,
                body: jsonDecoder,
            })),
        }))),
        outcomes: d.array(d.string),
        viewport: d.type({
            width: d.number,
            height: d.number,
        }),
    }))(d.type({
        id: d.string,
        visit: d.type({ path: d.string }),
        initial: d.string,
        states: d.record(d.partial({
            xstate: d.partial({
                always: d.string,
            }),
            type: d.literal("final"),
            tests: actionD,
            on: d.record(d.partial({
                target: d.string,
                actions: actionD,
            })),
        })),
    }));
};
const bar = configDecoder();
class _ {
    constructor() {
        this.Action = actionDecoder();
        this.Configuration = configDecoder();
    }
}
exports.default = (json) => configDecoder().decode(json);
const defaultSelectorWrapper = (selector) => `[data-testid~="${selector}"]`;
const defaultPorts = {
    ci: 7777,
    prod: 7777,
    dev: 3000,
};
const make = (actionsParser) => (withPlans) => ({ selectorWrapper = defaultSelectorWrapper, ports: ports_ = defaultPorts, server = "http://localhost", xstateInspect = false, } = {
    selectorWrapper: defaultSelectorWrapper,
    ports: defaultPorts,
    server: "http://localhost",
    xstateInspect: false,
}) => {
    const ports = Object.assign(Object.assign({}, defaultPorts), ports_);
    const ci = process.env.CI === "true";
    const prod = process.env.NODE_ENV === "production";
    const port = ci && ports.ci ? ports.ci : ci || prod ? ports.ci || ports.prod : ports.dev;
    return (json) => {
        const eitherConfig = configDecoder().decode(json);
        if (eitherConfig._tag === "Right") {
            const config = eitherConfig.right;
            const machineTemplate = {
                id: config.id,
                initial: config.initial,
                states: {},
                describe: {},
            };
            const eventMap = {};
            Object.keys(config.states).forEach((state) => {
                const { type, tests, on: events = {}, xstate = {} } = config.states[state];
                const meta = tests && {
                    test: (cy, state) => {
                        return actionsParser(selectorWrapper)(buffer)(tests)(cy);
                    },
                };
                const on = Object.keys(events || {}).reduce((acc, next) => {
                    const event = events[next];
                    acc[next] = {
                        target: event.target,
                        actions: [],
                    };
                    if (event.actions) {
                        const actions = event.actions;
                        eventMap[next] = {
                            exec: (cy) => actionsParser(selectorWrapper)(buffer)(actions)(cy),
                        };
                    }
                    else {
                        eventMap[next] = {
                            exec: () => true,
                        };
                    }
                    return acc;
                }, {});
                const stateNode = Object.assign({
                    meta,
                    on,
                    type,
                }, xstate);
                machineTemplate.states[state] = stateNode;
            });
            const machine = xstate_1.createMachine(machineTemplate);
            const buffer = [];
            const pattern = [];
            const model = test_1.createModel(machine).withEvents(eventMap);
            const plans = model.getSimplePathPlans();
            const visitPath = /^\//.test(config.visit.path)
                ? config.visit.path
                : `/${config.visit.path}`;
            const q = /\?/.test(visitPath) ? "&" : "?";
            const url = `${server}${port ? ':'+port : ''}${visitPath}${q}xstate-inspect=${xstateInspect}`;
            withPlans({ plans, buffer, pattern, url, config, selectorWrapper });
        }
    };
};
exports.make = make;
